#include <glib.h>

#include <libral.h>

int main (int argc, char* argv[])
{
  RDate* date;
  RDate* copy;

  g_print("\n");

  g_type_init();
  r_lib_init();

  date = r_date_new();
  g_print("\nDate is undefined, try to get contents");
  g_print("\nExpected: BadDay, BadMonth, BadYear, false, false, unknown");
  g_print("\n\tDay: %s",   r_date_get_day(R_DATE(date)));
  g_print("\n\tMonth: %s", r_date_get_month(R_DATE(date)));
  g_print("\n\tYear: %s",  r_date_get_year(R_DATE(date)));
  g_print("\n\tDate is known: %s", r_date_is_known(R_DATE(date)) ? 
	  "true" : "false");
  g_print("\n\tDate is valid: %s", r_date_is_valid(R_DATE(date)) ? 
	  "true" : "false");  
  g_print("\n\tHuman date: %s", r_date_get_human_date(R_DATE(date)));
 
  g_print("\n");  
  g_print("\nSet date to 18/03/1973");
  r_date_set_day(date, 18);
  r_date_set_month(date, 3);
  r_date_set_year(date, 1973);

  g_print("\n");
  g_print("\nPrint date's value");
  g_print("\n\tDay: %s",   r_date_get_day(R_DATE(date)));
  g_print("\n\tMonth: %s", r_date_get_month(R_DATE(date)));
  g_print("\n\tYear: %s",  r_date_get_year(R_DATE(date)));
  g_print("\n\tDate is known: %s", r_date_is_known(R_DATE(date)) ? 
	  "true" : "false");
  g_print("\n\tDate is valid: %s", r_date_is_valid(R_DATE(date)) ? 
	  "true" : "false");  
  g_print("\n\tHuman date: %s", r_date_get_human_date(R_DATE(date)));

  g_print("\n");
  g_print("\nCopy date");
  copy = r_date_copy(R_DATE(date));
  g_print("\nPrint date's value");
  g_print("\n\tDay: %s",   r_date_get_day(R_DATE(copy)));
  g_print("\n\tMonth: %s", r_date_get_month(R_DATE(copy)));
  g_print("\n\tYear: %s",  r_date_get_year(R_DATE(copy)));
  g_print("\n\tDate is known: %s", r_date_is_known(R_DATE(copy)) ? 
	  "true" : "false");
  g_print("\n\tDate is valid: %s", r_date_is_valid(R_DATE(copy)) ? 
	  "true" : "false");  
  g_print("\n\tHuman date: %s", r_date_get_human_date(R_DATE(copy)));  
  

  g_print("\n");
  g_print("\nFree date and copy");
  r_date_free(date);
  r_date_free(copy);
  g_print("\nCheck (errors expected)...");
  g_print("\n\tDate is valid: %s", r_date_is_valid(R_DATE(date)) ? 
	  "true" : "false");  
  g_print("\n\tDate is valid: %s", r_date_is_valid(R_DATE(copy)) ? 
	  "true" : "false");  
  return 0;
}

